

package src;

import java.util.ArrayList;

public class Aktivitaet {
	private ArrayList<ActivityNode> actionNodes;
	private ArrayList<ObjectNode> objectNodes;
	private ArrayList<Transition> transitions;
	private ArrayList<AcSignal> signals;
	@SuppressWarnings("unused")
	private String name = "Example";
	ActivityNode temp = null;
	ObjectFlow of;
	ArrayList<Pin> pins;
	
	public Aktivitaet(){
		actionNodes = new ArrayList<ActivityNode>();
		objectNodes = new ArrayList<ObjectNode>();
		transitions = new ArrayList<Transition>();
		signals = new ArrayList<AcSignal>();
		pins = new ArrayList<Pin>();
		
		//Parse through all Signals and create the classes
		signals.add(new AcSignal("enable"));		
		addAllNodes();		
		createTransitions();
		
		printActionNodes();
		printObjectNodes();
		printTransitions();
	}
	
	public void addAllNodes(){
		
		actionNodes.add(new ac0());
		actionNodes.add(new Generate2());
	
		temp = actionNodes.get(actionNodes.size()-1);
		pins.addAll(temp.getPinList());

		actionNodes.add(new ac1());
		actionNodes.add(new dec_ac4());
		actionNodes.add(new dec_ac5());
		actionNodes.add(new Mul());
	
		temp = actionNodes.get(actionNodes.size()-1);
		pins.addAll(temp.getPinList());

		actionNodes.add(new Generate5());
	
		temp = actionNodes.get(actionNodes.size()-1);
		pins.addAll(temp.getPinList());

		actionNodes.add(new fork_ac6());
		actionNodes.add(new Display());
	
		temp = actionNodes.get(actionNodes.size()-1);
		pins.addAll(temp.getPinList());

		actionNodes.add(new Generate7());
	
		temp = actionNodes.get(actionNodes.size()-1);
		pins.addAll(temp.getPinList());

		actionNodes.add(new Add());
	
		temp = actionNodes.get(actionNodes.size()-1);
		pins.addAll(temp.getPinList());

		actionNodes.add(new Receive_Enable(signals));
		actionNodes.add(new Send_Enable(getSignalWithName("enable")));
		
	}
	
	//Method to check, if the requested signal exists in the signals list. If the signal is not existing, it is created!
	public AcSignal createSignal(String sig){
		AcSignal tmp = null;
		
		for(int i=0; i<= signals.size()-1; i++){
			if(signals.get(i).getName().compareTo(sig) == 0)
				tmp = signals.get(i);
		}
		
		if (tmp == null) {
			tmp = new AcSignal(sig);
			signals.add(tmp);
		}
		
		return tmp;
	}
	
	public void printActionNodes() {
		System.out.println("\nAction Nodes (NAME, ID, Misc):");
		for (int i = 0; i <= actionNodes.size() - 1; i++) {
			System.out.println(actionNodes.get(i).toString());
		}
	}
	
	public void printObjectNodes() {
		System.out.println("\nObject nodes (NAME, ID):");
		for (int i = 0; i <= objectNodes.size() - 1; i++) {
			System.out.println(objectNodes.get(i).toString());
		}
	}
	
	public void createTransitions(){
		Transition trans;
		
		trans = new ControlFlow("ac9");
		trans.setSourceActivity(getRightActivity("dec_ac4"));
		trans.setTargetActivity(getRightActivity("ac1"));
		trans.getTargetActivity().setSourceTrans(trans);
		trans.getSourceActivity().setTargetTrans(trans);
		transitions.add(trans);

		trans = new ControlFlow("ac10");
		trans.setSourceActivity(getRightActivity("dec_ac5"));
		trans.setTargetActivity(getRightActivity("dec_ac4"));
		trans.getTargetActivity().setSourceTrans(trans);
		trans.getSourceActivity().setTargetTrans(trans);
		transitions.add(trans);

		trans = new ControlFlow("ac11");
		trans.setSourceActivity(getRightActivity("ac1"));
		trans.setTargetActivity(getRightActivity("dec_ac5"));
		trans.getTargetActivity().setSourceTrans(trans);
		trans.getSourceActivity().setTargetTrans(trans);
		transitions.add(trans);

		trans = new ControlFlow("ac12");
		trans.setSourceActivity(getRightActivity("fork_ac6"));
		trans.setTargetActivity(getRightActivity("Generate2"));
		trans.getTargetActivity().setSourceTrans(trans);
		trans.getSourceActivity().setTargetTrans(trans);
		transitions.add(trans);

		trans = new ControlFlow("ac13");
		trans.setSourceActivity(getRightActivity("fork_ac6"));
		trans.setTargetActivity(getRightActivity("Generate5"));
		trans.getTargetActivity().setSourceTrans(trans);
		trans.getSourceActivity().setTargetTrans(trans);
		transitions.add(trans);

		trans = new ControlFlow("ac14");
		trans.setSourceActivity(getRightActivity("dec_ac5"));
		trans.setTargetActivity(getRightActivity("fork_ac6"));
		trans.getTargetActivity().setSourceTrans(trans);
		trans.getSourceActivity().setTargetTrans(trans);
		transitions.add(trans);

		trans = new ControlFlow("ac15");
		trans.setSourceActivity(getRightActivity("ac0"));
		trans.setTargetActivity(getRightActivity("dec_ac4"));
		trans.getTargetActivity().setSourceTrans(trans);
		trans.getSourceActivity().setTargetTrans(trans);
		transitions.add(trans);

		trans = new ControlFlow("ac16");
		trans.setSourceActivity(getRightActivity("fork_ac6"));
		trans.setTargetActivity(getRightActivity("Generate7"));
		trans.getTargetActivity().setSourceTrans(trans);
		trans.getSourceActivity().setTargetTrans(trans);
		transitions.add(trans);

		trans = new ControlFlow("ac17");
		trans.setSourceActivity(getRightActivity("Receive_Enable"));
		trans.setTargetActivity(getRightActivity("Generate2"));
		trans.getTargetActivity().setSourceTrans(trans);
		trans.getSourceActivity().setTargetTrans(trans);
		transitions.add(trans);

		
		of = new ac18();
		of.setSourcePin((OutputPin)getRightPin("Mul_out"));
		of.setTargetPin((InputPin)getRightPin("Display_in"));
		of.getSourcePin().setTargetTrans(of);
		
		transitions.add(of);		

		of = new ac19();
		of.setSourcePin((OutputPin)getRightPin("Generate2_out"));
		of.setTargetPin((InputPin)getRightPin("Mul_in1"));
		of.getSourcePin().setTargetTrans(of);
		
		transitions.add(of);		

		of = new ac20();
		of.setSourcePin((OutputPin)getRightPin("Generate5_out"));
		of.setTargetPin((InputPin)getRightPin("Add_in1"));
		of.getSourcePin().setTargetTrans(of);
		
		transitions.add(of);		

		of = new ac21();
		of.setSourcePin((OutputPin)getRightPin("Generate7_out"));
		of.setTargetPin((InputPin)getRightPin("Add_in2"));
		of.getSourcePin().setTargetTrans(of);
		
		transitions.add(of);		

		of = new ac22();
		of.setSourcePin((OutputPin)getRightPin("Add_out"));
		of.setTargetPin((InputPin)getRightPin("Mul_in2"));
		of.getSourcePin().setTargetTrans(of);
		
		transitions.add(of);		

	}
	
	public void printTransitions() {
		System.out.println("\nTransitions:");
		for (int i = 0; i <= transitions.size() - 1; i++) {
			System.out.print(transitions.get(i).getName() + ": ");
			if (transitions.get(i).getSourceActivity() != null)
				System.out.print(" "+ transitions.get(i).getSourceActivity().getName());
			else {
				if (transitions.get(i).getSourceObject() != null)
					System.out.print(" "+ transitions.get(i).getSourceObject().getName());
				else
					System.out.print(" "+ ((ObjectFlow)transitions.get(i)).getSourcePin().getName());
			}
			
			if (transitions.get(i).getTargetActivity() != null)
				System.out.println(" TO " + transitions.get(i).getTargetActivity().getName());
			else {
				if (transitions.get(i).getTargetObject() != null)
					System.out.println(" TO "+ transitions.get(i).getTargetObject().getName());
				else
					System.out.println(" TO "+ ((ObjectFlow)transitions.get(i)).getTargetPin().getName());
			}
		}
		System.out.println();
	}
	
	public ActivityNode getRightActivity(String _name){
		ActivityNode returner = null;
		
		for(int i = 0; i <= actionNodes.size()-1; i++){
			if (actionNodes.get(i).getName().compareTo(_name) == 0)
				returner = actionNodes.get(i);
		}
		return returner;
	}
	
	public ObjectNode getRightObject(String _name){
		ObjectNode returner = null;
		
		for(int i = 0; i <= objectNodes.size()-1; i++){
			if (objectNodes.get(i).getName().compareTo(_name) == 0)
				returner = objectNodes.get(i);
		}
		return returner;
	}

	public AcSignal getSignalWithName(String signalName){
		AcSignal tmp = null;
		for(int i = 0; i<= signals.size()-1; i++){
			if (signals.get(i).getName().compareTo(signalName) == 0)
				tmp = signals.get(i);
		}
		
		return tmp;
	}	
	
	public Pin getRightPin(String s){
		Pin tmp = null;
		for(int i = 0; i<= pins.size()-1; i++){
			if (pins.get(i).getName().compareTo(s) == 0)
				tmp = pins.get(i);
		}
		
		return tmp;
	}
}

