 /**
 * $Id$ 
 * $Author$
 * $LastChangedDate$
 * $Revision$
 **/

package extensions;

import java.util.ArrayList;


public class JavaHelpersGen {
	
	static int countUp = 0;
	static int iCountUp2 = 0;
	static ArrayList<String> actionNodeTypes = new ArrayList<String>();
	static ArrayList<String> objectNodeTypes = new ArrayList<String>();
	static String cbaHeader = "";
	static ArrayList<String> imports;
	
	public final static String str2int(String str){
		return str.replaceAll("\\D", "");  
	}
	
	public final static String countUp(){
		countUp++;
		return Integer.toString(countUp);
	}
	
	public final static int determineMetaType(String type){
		int iTmp = 0;
		//ReceiveSignalEvent, SendSignalAction, TimedEvent
		
		if(type.compareTo("uml::AcceptEventAction")==0 || type.compareTo("uml::SendSignalAction")==0)
			iTmp = 1;
		
		if(type.compareTo("uml::TimedEvent")==0)
			iTmp = 2;
		
		return iTmp;
	}
	
	public final static String metaProperty(int prop){
		String sTmp = "" ;
		return sTmp;
	}
	
	/**
	 * Adds a type to the type list, but only if there is not such an entry already
	 * @param str
	 */
	public final static void addActionType(String str){
		boolean isIn = false;
		
		for(int i=0; i<=actionNodeTypes.size()-1; i++){
			if(actionNodeTypes.get(i).compareTo(str) == 0)
				isIn = true;
		}
		
		if (!isIn)
			actionNodeTypes.add(str);
	}
	
	public final static void addObjectType(String str){
		boolean isIn = false;
		
		for(int i=0; i<=objectNodeTypes.size()-1; i++){
			if(objectNodeTypes.get(i).compareTo(str) == 0)
				isIn = true;
		}
		
		if (!isIn)
			objectNodeTypes.add(str);
	}
	
	/**
	 * returns a String which contains class definitions for all types in the type list. 
	 * @return
	 */
	public final static String getActionNodes(){
		String sSetGetName = "\n\tpublic void setName(String _n){\n\t\tname = _n;\n\t}\n\tpublic String getName(){\n\t\treturn name;\n\t}";
		String tmp = "";
		for(int i=0; i<=actionNodeTypes.size()-1; i++){
			tmp += "class " + actionNodeTypes.get(i) + " extends ActivityNode {\n\tprivate String name;\n\n\tpublic " +actionNodeTypes.get(i)+"(String _name) {\n\t\tname = _name;\n\t}\n"+sSetGetName+"\n}\n\n";
		}
		return tmp;
	}
	
	public final static String getObjectNodes(){
		String sSetGetName = "\n\tpublic void setName(String _n){\n\t\tname = _n;\n\t}\n\tpublic String getName(){\n\t\treturn name;\n\t}";
		
		String tmp = "";
		for(int i=0; i<=objectNodeTypes.size()-1; i++){
			tmp += "class " + objectNodeTypes.get(i) + " extends ObjectNode {\n\tprivate String name;\n\n\tpublic " +objectNodeTypes.get(i)+"(String _name) {\n\t\tname = _name;\n\t}\n"+sSetGetName+"\n}\n\n";
		}
		return tmp;
	}
	
	public final static String getGenData(String s){
		String tmp = s;
		tmp = s.replaceAll("\\D", "");
		if(s.compareTo("") == 0)
			tmp = String.valueOf(0);
		
		return tmp;
	}
	
	
	public final static void collectImports(String s){
		if(imports == null)
			imports = new ArrayList<String>();
		
		if(s != null)
			if(!imports.contains(s))
				imports.add(s);
	}
	
	public final static String getImports(){
		String tmp = "";
		if (imports != null)
			for (int i = 0; i<= imports.size()-1; i++)
				tmp = tmp + "import src." + imports.get(i) + ".*;\n";
		
		return tmp;
	}
	
	/**
	 * Checks, if the passed String contains generator, generate or s.th like this
	 * @param st
	 * @return
	 */
	public final static boolean isGenerator(String st){
		boolean isGen = false;
		
		 if(st.contains("enerator") || st.contains("enerate"))
	          isGen = true;
		
		
		return isGen;
	}
	
}
