package extensions;

//Here are some helper functions which makes life easier

public class JavaHelpers {
	static int iCount = 0;
	
	/**
	 * If _name is empty, set an default ("ac[Number]") one. If name is not empty, replace all blanks
	 * @param _name
	 * @return
	 */
	public static String getGoodName(String _name){
		String sTmp ="";
		
		if(_name.isEmpty()) {
			sTmp = "ac" + Integer.toString(iCount);
			iCount++;
		}
		else{
			sTmp = _name.replaceAll(" ", "_");
			sTmp = sTmp.replaceAll("[()]", "");		
		}
		return sTmp;
	}

	/**
	 * Returns true, if str is "uml::ReceiveSignalEvent" 
	 * @param str
	 * @return
	 */
	public final static boolean isWithSignal(String str){
		boolean b = false;
		if(str.compareTo("uml::ReceiveSignalEvent") == 0)
			b = true;
		else
			b = false;
		
		return b;
	}
	
	/**
	 * Parse str, remove all non-number characters and return the number as integer
	 * @param str
	 * @return
	 */
	public final static int str2int(String str){
		return Integer.parseInt(str.replaceAll("\\D", ""));  //Regex: \D means all non-numbers. Additional \ to prevent interpretation as Escape-sequence
	}
	
	public final static String removeUML(String str){
		return str.replace("uml::", "");
	}
	
	//TODO Test this!!!   -> Ha, tested. Die MF!
    public final static String getGoodType(String st){
        String tmp = "";
        if(st.matches("[B|b]oolean") || st.matches("[B|b]bool"))
            tmp = "java.lang.Boolean";
       
        if(st.matches("String"))
            tmp = "java.lang.String";
       
        if(st.matches("[F|f]loat") || st.matches("[D|d]ouble") || st.matches("UnlimitedNatural"))
            tmp = "java.lang.Double";
       
        if(st.matches("[i|I]nteger") || st.matches("int") || st.matches("long"))
            tmp = "java.lang.Integer";
       
        if (tmp.compareTo("") == 0)
            tmp = "null";
       
        return tmp;
    }


	
	
	
}
